<%@page import="java.net.URLDecoder, java.util.Set"%>
<%

  if (resp == null || resp.length() == 0) {
      out.print("Communication failed. Please review payment server return response (put code into debug mode).");
  } else {
    // [Snippet] howToDecodeResponse - start
    // loop through server response and form an associative array
    // name/value pair format
    String[] pairArray = resp.split("&");
    Map<String, String> responseMap = new HashMap<String, String>();
    for (String pair : pairArray) {
        String[] param = pair.split("=");
        responseMap.put(param[0], param[1]);
    }
    // [Snippet] howToDecodeResponse - end
    // [Snippet] howToParseResponse - start
    String result = responseMap.get("result");
    // [Snippet] howToParseResponse - end
    String errorMessage = null;
    String errorCode = null;
    String gatewayCode = null;
    // Form error string if error is triggered
    if (result != null && result.equals("FAIL")) {

        String failureExplanations = responseMap.get("failureExplanation");
        String supportCode = responseMap.get("supportCode");
        if (failureExplanations != null) {
           errorMessage = URLDecoder.decode(failureExplanations);
        } else if (supportCode != null) {
            errorMessage = URLDecoder.decode(supportCode);
        }
        else {
            errorMessage = "Reason unspecified.";
        }
        String failureCode = responseMap.get("failureCode");
        if (failureCode != null) {
            errorCode = "Error (" + failureCode + ")";
        } else {
            errorCode = "Error (UNSPECIFIED)";
        }
    } else {
        gatewayCode = responseMap.get("response.gatewayCode");
        if (gatewayCode != null)
            gatewayCode = URLDecoder.decode(gatewayCode);
        else
            gatewayCode = "Response not received.";
    }
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <link rel="stylesheet" type="text/css" href="assets/paymentstyle.css" />
    <head>
            <title>DirectApi Example</title>
            <meta http-equiv="Content-Type" content="text/html, charset=iso-8859-1">
    </head>
    <body>

    <center><h1><br/>DirectApi JSP NVP Example</h1></center>
    <center><h3>Receipt Page</h3></center><br/><br/>

    <table width="60%" align="center" cellpadding="5" border="0">

    <%
        // echo HTML displaying Error headers if error is found
        if (errorCode != null || errorMessage != null) {
    %>
            <tr class="title">
             <td colspan="2" height="25"><P><strong>&nbsp;Error Response</strong></P></td>
         </tr>
         <tr>
             <td align="right" width="50%"><strong><i><%=errorCode%>: </i></strong></td>
             <td width="50%"><?=$errorMessage?></td>
         </tr>
    <%
        }

        else {
    %>
            <tr class="title">
             <td colspan="2" height="25"><P><strong>&nbsp;<%=gatewayCode%></strong></P></td>
         </tr>
         <tr>
             <td align="right" width="50%"><strong><i>Result: </i></strong></td>
             <td width="50%"><%=result%></td>
         </tr>
    <%
        }
    %>
            <!-- Credit Card Fields -->

         <tr class="title">
             <td colspan="2" height="20"><P><strong>&nbsp;All Response Fields</strong></P></td>
         </tr>
        <%
            int shade = 0;
            Set<String> keys = responseMap.keySet();
            // Output field: value HTML in response fields HTML table
            for(String key:keys) {
                if (shade % 2 == 0) {
                    out.print("<tr class=\"shade\">");
                } else {
                    out.print("<tr>");
                }

                shade++;
        %>
            <td align="right" width="50%"><strong><i><%=key %>: </i></strong></td>
            <td width="50%"><%=URLDecoder.decode(responseMap.get(key), "UTF-8")%></td>
         </tr>
        <%
            }
}
        %>
    </table>
    <br/><br/>
   </body>
</html>